/*
 * convert.c
 *
 * Josef Kufner <jkufner@seznam.cz>
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>

#include "main.h"
#include "debug.h"
#include "convert.h"


char *convert_hd_to_var (char *var) {
	static char *str = NULL;
	char *p_str;
	unsigned int level;

		if (str)
			free(str);

		str = (char *) malloc_c((strlen(var) + 1 + 2) * sizeof(char));		/* + 2 pro zavorky */
		strcpy(str, var);
		p_str = str;
	
		/* Odstraneni $ */
		while((p_str = strchr(str, '$')) != NULL)
			*p_str = ' ';


		/* vypusteni [ ... ] */

		for (level = 0, p_str = str; *p_str != '\0'; p_str += sizeof(char)) {
			if (*p_str == '[')
				level++;

			if (level) {
				if (*p_str == ']')
					level--;

				*p_str = ' ';
			}
		}
		
		PRINT_DEBUG_PRG_L2("Convert variable: \"%s\" -> \"%s\"", var, str);

		return str;
}

char *convert_val_to_tex (char *val) {
	static char number[MAX_LEN];
	char str[MAX_LEN];
	char *p_dot, *p_exp, *p_val;

	/* inicialize strings */
	strcpy(str, "");
	strcpy(number, "");
	
	/* initialize pointers */
	p_val = val;
	p_dot = NULL;
	p_exp = NULL;
	
	while (1) {
		p_dot = strchr(p_val, '.');
		p_exp = strchr(p_val, 'e');
		PRINT_DEBUG_PRG_L2("Found '.' at %d and 'e' at %d", p_dot - p_val, p_exp - p_val);
		PRINT_DEBUG_PRG_L2("\t\t(p_dot = %p, p_exp = %p)", p_dot, p_exp);
		
		if (p_dot != NULL && (p_exp == NULL || p_dot < p_exp)) {
			/* dot is first */
			*p_dot = '\0';
			sprintf(str, "%s{,}", p_val);			/* print all to '.' */
			strcat(number, str);
			p_val = p_dot + sizeof(char);
			PRINT_DEBUG_PRG_L2("Formating(.)... \"%s\"", number);
		
		} else if (p_exp != NULL && (p_exp < p_dot || p_dot == NULL)) {
			/* exp is first */
			*p_exp = '\0';
			sprintf(str, "%s\\cdot10^{", p_val);		/* print all to 'e' */
			strcat(number, str);
			p_val = p_exp + sizeof(char);

			/* print number after 'e' */
			while (isdigit(*p_val) || *p_val == '+' || *p_val == '-') {
				number[strlen(number)+1] = '\0';
				number[strlen(number)] = *p_val;
				p_val += sizeof(char);
			}
			
			strcat(number, "}");
			
			PRINT_DEBUG_PRG_L2("Formating(e)... \"%s\"", number);
		} else {
			/* there is NOT p_dot or p_exp */
			sprintf(str, "%s", p_val);
			strcat(number, str);
			break;
		}
	}

	return number;
}
