/*
 * lists.h
 *
 * Josef Kufner <jkufner@seznam.cz>
 *
 * 
 */

#ifndef TEXTABLE_LISTS_H
#define TEXTABLE_LISTS_H

typedef enum { NORMAL, SCI } FORMAT_MODE;

typedef struct s_item {
	/* every used */
	char name[MAX_LEN];
	char expr[MAX_LEN];

	/* used only in VAR_LIST */
	char val[MAX_LEN];

	/* used only in FORMAT_LIST */
	int format_digits;
	FORMAT_MODE format_mode;
	
	/* pointer na dalsi polozku */
	struct s_item *next;
} LIST_ITEM;

typedef enum {
	VAR_LIST = 0,
	ADD_LIST,
	DATA_LIST,
	HEAD_LIST,
	FORMAT_LIST,
	EXAMPLE_LIST,
	MAX_LIST
} LIST_ID;

/* Operace se seznamy */
int create_list(LIST_ID list_id);
int destroy_list(LIST_ID list_id);
int clear_list(LIST_ID list_id);
int is_list_empty(LIST_ID list_id);

int pop_list_pos(LIST_ID list_id);
int push_list_pos(LIST_ID list_id);

/* Operace s polozkama */
int rewind_list(LIST_ID list_id);
LIST_ITEM *create_item(LIST_ID list_id);
LIST_ITEM *get_item(LIST_ID list_id);

#endif
